#line 1 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock/MCP23S09 Based Soft SPI LCD/MCP23S09 Based SW SPI LCD.c"

sbit SoftSpi_SDI at RA2_bit;
sbit SoftSpi_SDO at RA0_bit;
sbit SoftSpi_CLK at RA1_bit;

sbit SoftSpi_SDI_Direction at TRISA2_bit;
sbit SoftSpi_SDO_Direction at TRISA0_bit;
sbit SoftSpi_CLK_Direction at TRISA1_bit;


sbit CS at RA5_bit;
sbit CS_Direction at TRISA5_bit;
#line 43 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock/MCP23S09 Based Soft SPI LCD/MCP23S09 Based SW SPI LCD.c"
char str[23];

void SPI_LCD_Cmd(char out_char) {

 char hi_n, lo_n;
 char rs = 0x00;

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(hi_n | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(hi_n | rs | 0x00 | 0x08);
 CS = 1;

 Delay_us(100);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(lo_n | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(lo_n | rs | 0x00 | 0x08);
 CS = 1;

 if(out_char == 0x01)Delay_ms(2);
}

void SPI_LCD_Chr(char row, char column, char out_char) {

 char hi_n, lo_n;
 char rs = 0x01;

 switch(row){

 case 1:
 SPI_LCD_Cmd(0x80 + (column - 1));
 break;
 case 2:
 SPI_LCD_Cmd(0xC0 + (column - 1));
 break;
 case 3:
 SPI_LCD_Cmd(0x94 + (column - 1));
 break;
 case 4:
 SPI_LCD_Cmd(0xD4 + (column - 1));
 break;
 };

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(hi_n | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(hi_n | rs | 0x00 | 0x08);
 CS = 1;

 Delay_us(100);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(lo_n | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(lo_n | rs | 0x00 | 0x08);
 CS = 1;
}

void SPI_LCD_Chr_Cp(char out_char) {

 char hi_n, lo_n;
 char rs = 0x01;

 hi_n = out_char & 0xF0;
 lo_n = (out_char << 4) & 0xF0;

 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(hi_n | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(hi_n | rs | 0x00 | 0x08);
 CS = 1;

 Delay_us(100);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(lo_n | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(lo_n | rs | 0x00 | 0x08);
 CS = 1;
}


void SPI_LCD_Init() {

 char rs = 0x00;

 Delay_ms(30);

 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(0x30 | rs | 0x04 | 0x08);

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(0x30 | rs | 0x00 | 0x08);
 CS = 1;


 Delay_ms(10);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(0x30 | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(0x30 | rs | 0x00 | 0x08);
 CS = 1;


 Delay_ms(10);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(0x30 | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(0x30 | rs | 0x00 | 0x08);
 CS = 1;


 Delay_ms(10);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(0x20 | rs | 0x04 | 0x08);
 CS = 1;

 Delay_us(50);
 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x09 );
 Soft_Spi_Write(0x20 | rs | 0x00 | 0x08);
 CS = 1;

 Delay_ms(10);

 SPI_LCD_Cmd(0x28);
 SPI_LCD_Cmd(0x06);
}

void SPI_LCD_Out(char row, char col, char *text) {
 while(*text)
 SPI_LCD_Chr(row, col++, *text++);
}

void SPI_LCD_Out_Cp(char *text) {
 while(*text)
 SPI_LCD_Chr_Cp(*text++);
}

void main() {

 CM1CON0 = 0x07;
 ANSELA = 0x00;
 TRISA= 0x08;
 PORTA = 0x00;

 CS_Direction = 0;
 CS = 1;

 Soft_Spi_Init();

 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x05 );
 Soft_Spi_Write(0x27);
 CS = 1;

 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x00 );
 Soft_Spi_Write(0x00);
 CS = 1;

 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x01 );
 Soft_Spi_Write(0x00);
 CS = 1;

 CS = 0;
 Soft_Spi_Write(0x40);
 Soft_Spi_Write( 0x06 );
 Soft_Spi_Write(0xFF);
 CS = 1;

 SPI_LCD_Init();
 SPI_LCD_Cmd( 0x0C );
 SPI_LCD_Cmd( 0x01 );

 SPI_LCD_Out(1,1,"MCP23S09 Based");
 SPI_LCD_Out(2,1,"Soft Spi LCD");
 SPI_LCD_Out(3,1,"16x2, 20x2, 20x4");
 SPI_LCD_Out(4,1,"PIC12F1840");

 while(1) {

 }
}
